> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://reference.flatfile.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://reference.flatfile.com/_mcp/server.

# Bulk Mutate

POST https://api.x.flatfile.com/v1/v1/workbooks/{workbookId}/flags/bulk-mutate
Content-Type: application/json

Performs bulk flag operations on records

Reference: https://reference.flatfile.com/api-reference/flags/bulk-mutate

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `workbookId` (string, required) — The workbook ID to manage flags for

### Body (application/json)

This endpoint expects a BulkMutateFlagsRequest.

- `operation` (enum, required) — The operation to perform
  - Allowed values: `apply`, `update`, `delete`, `replace`
- `slug` (string, required) — The flag slug to operate on
- `flag` (FlagMutationData, optional) — Flag data for apply/update operations
- `exceptions` (list of string, optional) — Record IDs to exclude from the operation
- `query` (string, optional) — Query string to filter records
- `filter` (any, optional) — Filter object to apply to records
- `filterField` (string, optional) — Field to filter on
- `searchValue` (string, optional) — Value to search for
- `searchField` (string, optional) — Field to search in
- `q` (string, optional) — General search query
- `ids` (list of string, optional) — Specific record IDs to target
- `snapshotLabel` (string, optional) — Label for snapshot before mutation

## Response

### 200

- `success` (boolean, required) — Whether the operation was successfully queued
- `jobId` (string, required) — The ID of the job handling the bulk mutation

## Types

### FlagMutationData

Flag data for mutation operations

- `label` (string, optional) — The flag label
- `colorHex` (string, optional) — The flag color in hex format

## Examples

### Apply

**Request**

```json
{
  "operation": "apply",
  "slug": "important",
  "flag": {
    "label": "Important",
    "colorHex": "#0090FF"
  },
  "snapshotLabel": "Before important flag application"
}
```

**Response**

```json
{
  "success": true,
  "jobId": "job_12345"
}
```

**SDK Code**

```typescript Apply
import { FlatfileClient } from "@flatfile/api";

const client = new FlatfileClient({ token: "YOUR_TOKEN" });
await client.flags.bulkMutate("us_wb_YOUR_ID", {
    operation: "apply",
    slug: "important",
    flag: {
        label: "Important",
        colorHex: "#0090FF"
    },
    snapshotLabel: "Before important flag application"
});

```

```python Apply
import requests

url = "https://api.x.flatfile.com/v1/v1/workbooks/us_wb_YOUR_ID/flags/bulk-mutate"

payload = {
    "operation": "apply",
    "slug": "important",
    "flag": {
        "label": "Important",
        "colorHex": "#0090FF"
    },
    "snapshotLabel": "Before important flag application"
}
headers = {
    "X-Disable-Hooks": "true",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```go Apply
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.x.flatfile.com/v1/v1/workbooks/us_wb_YOUR_ID/flags/bulk-mutate"

	payload := strings.NewReader("{\n  \"operation\": \"apply\",\n  \"slug\": \"important\",\n  \"flag\": {\n    \"label\": \"Important\",\n    \"colorHex\": \"#0090FF\"\n  },\n  \"snapshotLabel\": \"Before important flag application\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("X-Disable-Hooks", "true")
	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Apply
require 'uri'
require 'net/http'

url = URI("https://api.x.flatfile.com/v1/v1/workbooks/us_wb_YOUR_ID/flags/bulk-mutate")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["X-Disable-Hooks"] = 'true'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"operation\": \"apply\",\n  \"slug\": \"important\",\n  \"flag\": {\n    \"label\": \"Important\",\n    \"colorHex\": \"#0090FF\"\n  },\n  \"snapshotLabel\": \"Before important flag application\"\n}"

response = http.request(request)
puts response.read_body
```

```java Apply
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.x.flatfile.com/v1/v1/workbooks/us_wb_YOUR_ID/flags/bulk-mutate")
  .header("X-Disable-Hooks", "true")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"operation\": \"apply\",\n  \"slug\": \"important\",\n  \"flag\": {\n    \"label\": \"Important\",\n    \"colorHex\": \"#0090FF\"\n  },\n  \"snapshotLabel\": \"Before important flag application\"\n}")
  .asString();
```

```php Apply
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.x.flatfile.com/v1/v1/workbooks/us_wb_YOUR_ID/flags/bulk-mutate', [
  'body' => '{
  "operation": "apply",
  "slug": "important",
  "flag": {
    "label": "Important",
    "colorHex": "#0090FF"
  },
  "snapshotLabel": "Before important flag application"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
    'X-Disable-Hooks' => 'true',
  ],
]);

echo $response->getBody();
```

```csharp Apply
using RestSharp;

var client = new RestClient("https://api.x.flatfile.com/v1/v1/workbooks/us_wb_YOUR_ID/flags/bulk-mutate");
var request = new RestRequest(Method.POST);
request.AddHeader("X-Disable-Hooks", "true");
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"operation\": \"apply\",\n  \"slug\": \"important\",\n  \"flag\": {\n    \"label\": \"Important\",\n    \"colorHex\": \"#0090FF\"\n  },\n  \"snapshotLabel\": \"Before important flag application\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Apply
import Foundation

let headers = [
  "X-Disable-Hooks": "true",
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "operation": "apply",
  "slug": "important",
  "flag": [
    "label": "Important",
    "colorHex": "#0090FF"
  ],
  "snapshotLabel": "Before important flag application"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.x.flatfile.com/v1/v1/workbooks/us_wb_YOUR_ID/flags/bulk-mutate")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Delete

**Request**

```json
{
  "operation": "delete",
  "slug": "important",
  "exceptions": [
    "rec_123",
    "rec_456"
  ]
}
```

**Response**

```json
{
  "success": true,
  "jobId": "job_12345"
}
```

**SDK Code**

```typescript Delete
import { FlatfileClient } from "@flatfile/api";

const client = new FlatfileClient({ token: "YOUR_TOKEN" });
await client.flags.bulkMutate("us_wb_YOUR_ID", {
    operation: "delete",
    slug: "important",
    exceptions: ["rec_123", "rec_456"]
});

```

```python Delete
import requests

url = "https://api.x.flatfile.com/v1/v1/workbooks/us_wb_YOUR_ID/flags/bulk-mutate"

payload = {
    "operation": "delete",
    "slug": "important",
    "exceptions": ["rec_123", "rec_456"]
}
headers = {
    "X-Disable-Hooks": "true",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```go Delete
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.x.flatfile.com/v1/v1/workbooks/us_wb_YOUR_ID/flags/bulk-mutate"

	payload := strings.NewReader("{\n  \"operation\": \"delete\",\n  \"slug\": \"important\",\n  \"exceptions\": [\n    \"rec_123\",\n    \"rec_456\"\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("X-Disable-Hooks", "true")
	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Delete
require 'uri'
require 'net/http'

url = URI("https://api.x.flatfile.com/v1/v1/workbooks/us_wb_YOUR_ID/flags/bulk-mutate")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["X-Disable-Hooks"] = 'true'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"operation\": \"delete\",\n  \"slug\": \"important\",\n  \"exceptions\": [\n    \"rec_123\",\n    \"rec_456\"\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Delete
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.x.flatfile.com/v1/v1/workbooks/us_wb_YOUR_ID/flags/bulk-mutate")
  .header("X-Disable-Hooks", "true")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"operation\": \"delete\",\n  \"slug\": \"important\",\n  \"exceptions\": [\n    \"rec_123\",\n    \"rec_456\"\n  ]\n}")
  .asString();
```

```php Delete
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.x.flatfile.com/v1/v1/workbooks/us_wb_YOUR_ID/flags/bulk-mutate', [
  'body' => '{
  "operation": "delete",
  "slug": "important",
  "exceptions": [
    "rec_123",
    "rec_456"
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
    'X-Disable-Hooks' => 'true',
  ],
]);

echo $response->getBody();
```

```csharp Delete
using RestSharp;

var client = new RestClient("https://api.x.flatfile.com/v1/v1/workbooks/us_wb_YOUR_ID/flags/bulk-mutate");
var request = new RestRequest(Method.POST);
request.AddHeader("X-Disable-Hooks", "true");
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"operation\": \"delete\",\n  \"slug\": \"important\",\n  \"exceptions\": [\n    \"rec_123\",\n    \"rec_456\"\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Delete
import Foundation

let headers = [
  "X-Disable-Hooks": "true",
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "operation": "delete",
  "slug": "important",
  "exceptions": ["rec_123", "rec_456"]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.x.flatfile.com/v1/v1/workbooks/us_wb_YOUR_ID/flags/bulk-mutate")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```